#include <assert.h>


BEGIN_GTBMOUSENS


inline bool Matrix4::operator==(const Matrix4 &m) const
{
#if 0
	return (real::is_equal(_m[0][0], m._m[0][0]) &&
		real::is_equal(_m[0][1], m._m[0][1]) &&
		real::is_equal(_m[0][2], m._m[0][2]) &&
		real::is_equal(_m[0][3], m._m[0][3]) &&
		
		real::is_equal(_m[1][0], m._m[1][0]) &&
		real::is_equal(_m[1][1], m._m[1][1]) &&
		real::is_equal(_m[1][2], m._m[1][2]) &&
		real::is_equal(_m[1][3], m._m[1][3]) &&
		
		real::is_equal(_m[2][0], m._m[2][0]) &&
		real::is_equal(_m[2][1], m._m[2][1]) &&
		real::is_equal(_m[2][2], m._m[2][2]) &&
		real::is_equal(_m[2][3], m._m[2][3]) &&
		
		real::is_equal(_m[3][0], m._m[3][0]) &&
		real::is_equal(_m[3][1], m._m[3][1]) &&
		real::is_equal(_m[3][2], m._m[3][2]) &&
		real::is_equal(_m[3][3], m._m[3][3]));
#else
return false;
#endif
}


inline bool Matrix4::operator!=(const Matrix4 &m) const
{
	return !(*this == m);
}


inline Matrix4 Matrix4::transpose() const
{
	return Matrix4(_m[0][0], _m[1][0], _m[2][0], _m[3][0],
		       _m[0][1], _m[1][1], _m[2][1], _m[3][1],
		       _m[0][2], _m[1][2], _m[2][2], _m[3][2],
		       _m[0][3], _m[1][3], _m[2][3], _m[3][3]);
}


inline const real_t *Matrix4::as_array() const
{
	return (const real_t *) _m;
}


inline real_t *Matrix4::as_array()
{
	return (real_t *) _m;
}


inline real_t *Matrix4::operator[](unsigned i)
{
	assert(i < 4);
	return _m[i];
}


inline const real_t *Matrix4::operator[](unsigned i) const
{
	assert(i < 4);
	return _m[i];
}


inline Matrix4 Matrix4::operator-()
{
	return Matrix4(-_m[0][0], -_m[0][1], -_m[0][2], -_m[0][3],
		       -_m[1][0], -_m[1][1], -_m[1][2], -_m[1][3],
		       -_m[2][0], -_m[2][1], -_m[2][2], -_m[2][3],
		       -_m[3][0], -_m[3][1], -_m[3][2], -_m[3][3]);
}


inline Matrix4 &Matrix4::operator+=(const Matrix4 &m)
{
	_m[0][0] += m._m[0][0];
	_m[0][1] += m._m[0][1];
	_m[0][2] += m._m[0][2];
	_m[0][3] += m._m[0][3];

	_m[1][0] += m._m[1][0];
	_m[1][1] += m._m[1][1];
	_m[1][2] += m._m[1][2];
	_m[1][3] += m._m[1][3];

	_m[2][0] += m._m[2][0];
	_m[2][1] += m._m[2][1];
	_m[2][2] += m._m[2][2];
	_m[2][3] += m._m[2][3];

	_m[3][0] += m._m[3][0];
	_m[3][1] += m._m[3][1];
	_m[3][2] += m._m[3][2];
	_m[3][3] += m._m[3][3];

	return *this;
}


inline Matrix4 &Matrix4::operator-=(const Matrix4 &m)
{
	_m[0][0] -= m._m[0][0];
	_m[0][1] -= m._m[0][1];
	_m[0][2] -= m._m[0][2];
	_m[0][3] -= m._m[0][3];

	_m[1][0] -= m._m[1][0];
	_m[1][1] -= m._m[1][1];
	_m[1][2] -= m._m[1][2];
	_m[1][3] -= m._m[1][3];

	_m[2][0] -= m._m[2][0];
	_m[2][1] -= m._m[2][1];
	_m[2][2] -= m._m[2][2];
	_m[2][3] -= m._m[2][3];

	_m[3][0] -= m._m[3][0];
	_m[3][1] -= m._m[3][1];
	_m[3][2] -= m._m[3][2];
	_m[3][3] -= m._m[3][3];

	return *this;
}


inline Matrix4 operator*(const Matrix4 &m1, const Matrix4 &m2)
{
	Matrix4 t;

	for (unsigned i = 0; i < 4; i++) {
		for (unsigned j = 0; j < 4; j++) {
			t._m[i][j] = 0.0;
			for (unsigned k = 0; k < 4; k++) {
				t._m[i][j] += m1._m[i][k] * m2._m[k][j];
			}
		}
	}
	return t;
}


inline Matrix4 &Matrix4::operator*=(const Matrix4 &m)
{
	*this = *this * m;
	return *this;
}


inline Matrix4 &Matrix4::operator*=(real_t a)
{
	_m[0][0] *= a;
	_m[0][1] *= a;
	_m[0][2] *= a;
	_m[0][3] *= a;

	_m[1][0] *= a;
	_m[1][1] *= a;
	_m[1][2] *= a;
	_m[1][3] *= a;

	_m[2][0] *= a;
	_m[2][1] *= a;
	_m[2][2] *= a;
	_m[2][3] *= a;

	_m[3][0] *= a;
	_m[3][1] *= a;
	_m[3][2] *= a;
	_m[3][3] *= a;

	return *this;
}


inline Matrix4 operator+(const Matrix4 &m1, const Matrix4 &m2)
{
	return Matrix4(m1._m[0][0] + m2._m[0][0],
		       m1._m[0][1] + m2._m[0][1],
		       m1._m[0][2] + m2._m[0][2],
		       m1._m[0][3] + m2._m[0][3],

		       m1._m[1][0] + m2._m[1][0],
		       m1._m[1][1] + m2._m[1][1],
		       m1._m[1][2] + m2._m[1][2],
		       m1._m[1][3] + m2._m[1][3],

		       m1._m[2][0] + m2._m[2][0],
		       m1._m[2][1] + m2._m[2][1],
		       m1._m[2][2] + m2._m[2][2],
		       m1._m[2][3] + m2._m[2][3],

		       m1._m[3][0] + m2._m[3][0],
		       m1._m[3][1] + m2._m[3][1],
		       m1._m[3][2] + m2._m[3][2],
		       m1._m[3][3] + m2._m[3][3]);
}


inline Matrix4 operator-(const Matrix4 &m1, const Matrix4 &m2)
{
	return Matrix4(m1._m[0][0] - m2._m[0][0],
		       m1._m[0][1] - m2._m[0][1],
		       m1._m[0][2] - m2._m[0][2],
		       m1._m[0][3] - m2._m[0][3],

		       m1._m[1][0] - m2._m[1][0],
		       m1._m[1][1] - m2._m[1][1],
		       m1._m[1][2] - m2._m[1][2],
		       m1._m[1][3] - m2._m[1][3],

		       m1._m[2][0] - m2._m[2][0],
		       m1._m[2][1] - m2._m[2][1],
		       m1._m[2][2] - m2._m[2][2],
		       m1._m[2][3] - m2._m[2][3],

		       m1._m[3][0] - m2._m[3][0],
		       m1._m[3][1] - m2._m[3][1],
		       m1._m[3][2] - m2._m[3][2],
		       m1._m[3][3] - m2._m[3][3]);
}


inline Matrix4 operator*(const real_t a, const Matrix4 &m)
{
	return Matrix4(
		a * m._m[0][0],
		a * m._m[0][1],
		a * m._m[0][2],
		a * m._m[0][3],

		a * m._m[1][0],
		a * m._m[1][1],
		a * m._m[1][2],
		a * m._m[1][3],

		a * m._m[2][0],
		a * m._m[2][1],
		a * m._m[2][2],
		a * m._m[2][3],

		a * m._m[3][0],
		a * m._m[3][1],
		a * m._m[3][2],
		a * m._m[3][3]);
}


inline Matrix4 operator*(const Matrix4 &m, real_t a)
{
	return a * m;
}


END_GTBMOUSENS
