BEGIN_GTBMOUSENS

inline Plane &Plane::operator=(const Plane &p)
{
	if (&p != this) {
		_n = p._n;
		_D = p._D;
	}
	return *this;
}


inline Vector3 &Plane::normal()
{
	return _n;
}

inline const Vector3 &Plane::normal() const
{
	return _n;
}

inline void Plane::set_normal(const Vector3& n)
{
    _n = n;
}

inline void Plane::setD(real_t v_D)
{
	_D = v_D;
}

inline real_t Plane::D() const
{
	return _D;
}


inline bool Plane::operator==(const Plane &p) const
{
return false;
}


inline bool Plane::operator!=(const Plane &p) const
{
	return !(*this == p);
}


inline real_t Plane::signed_distance(const Point3 &p) const
{
	return (p.x() * _n.x() +
		p.y() * _n.y() +
		p.z() * _n.z()) + _D;
}


inline real_t Plane::distance(const Point3 &p) const
{
	return fabs(signed_distance(p));
}


END_GTBMOUSENS
