#include "gtbmouse.h"


BEGIN_GTBMOUSENS


const Vector2 VECTOR2_ZERO(0.0, 0.0);
const Vector2 VECTOR2_POSITIVE_X(1.0, 0.0);
const Vector2 VECTOR2_NEGATIVE_X(-1.0, 0.0);
const Vector2 VECTOR2_POSITIVE_Y(0.0, 1.0);
const Vector2 VECTOR2_NEGATIVE_Y(0.0, -1.0);


Vector2::Vector2()
{
	_v[0] = 0.0;
	_v[1] = 0.0;
}


Vector2::Vector2(const Vector2 &v)
{
	_v[0] = v._v[0];
	_v[1] = v._v[1];
}


Vector2::Vector2(real_t vx, real_t vy)
{
	_v[0] = vx;
	_v[1] = vy;
}


Vector2::Vector2(const real_t v[2])
{
	_v[0] = v[0];
	_v[1] = v[1];
}


Vector3 Vector2::cross(const Vector2 &v) const
{
	return Vector3(0.0,
		       0.0,
		       (_v[0] * v._v[1]) - (_v[1] * v._v[0]));
}


Vector2 &Vector2::rotate(real_t theta)
{
	real_t c = cos(theta);
	real_t s = sin(theta);
	real_t vx = _v[0];
	real_t vy = _v[1];
	_v[0] = (vx * c) - (vy * s);
	_v[1] = (vx * s) + (vy * c);
	return *this;
}


END_GTBMOUSENS
