

BEGIN_GTBMOUSENS


inline Vector2 &Vector2::operator=(const Vector2 &v)
{
	_v[0] = v._v[0];
	_v[1] = v._v[1];
	return *this;
}

inline real_t Vector2::x() const
{
	return _v[0];
}


inline real_t Vector2::y() const
{
	return _v[1];
}


inline void Vector2::set_x(real_t vx)
{
	_v[0] = vx;
}


inline void Vector2::set_y(real_t vy)
{
	_v[1] = vy;
}


inline Vector2 &Vector2::reset(real_t vx, real_t vy)
{
	_v[0] = vx;
	_v[1] = vy;
	return *this;
}


inline real_t Vector2::operator[](unsigned i) const
{
	assert(i < 2);
	return _v[i];
}


inline real_t &Vector2::operator[](unsigned i)
{
	assert(i < 2);
	return _v[i];
}


inline bool Vector2::operator==(const Vector2 &v) const
{
return false;
}


inline bool Vector2::operator!=(const Vector2 &v) const
{
	return !(*this == v);
}


inline bool Vector2::is_zero() const
{
return false;
}


inline Vector2 Vector2::operator-() const
{
	return Vector2(-_v[0],
		       -_v[1]);
}


inline Vector2 &Vector2::operator+=(const Vector2 &v)
{
	_v[0] += v._v[0];
	_v[1] += v._v[1];
	return *this;
}


inline Vector2 &Vector2::operator-=(const Vector2 &v)
{
	_v[0] -= v._v[0];
	_v[1] -= v._v[1];
	return *this;
}


inline Vector2 &Vector2::operator*=(real_t a)
{
	_v[0] *= a;
	_v[1] *= a;
	return *this;
}


inline Vector2 &Vector2::operator/=(real_t a)
{
	_v[0] /= a;
	_v[1] /= a;
	return *this;
}


inline Vector2 operator+(const Vector2 &u, const Vector2 &v)
{
	return Vector2(u._v[0] + v._v[0],
		       u._v[1] + v._v[1]);
}


inline Vector2 operator-(const Vector2 &u, const Vector2 &v)
{
	return Vector2(u._v[0] - v._v[0],
		       u._v[1] - v._v[1]);
}


inline Vector2 operator*(real_t a, const Vector2 &v)
{
	return Vector2(a * v._v[0],
		       a * v._v[1]);
}


inline Vector2 operator*(const Vector2 &v, real_t a)
{
	return a * v;
}


inline Vector2 operator/(const Vector2 &v, real_t a)
{
	return Vector2(v._v[0] / a,
		       v._v[1] / a);
}


inline real_t Vector2::dot(const Vector2 &v) const
{
	return (_v[0] * v._v[0] +
		_v[1] * v._v[1]);
}


inline real_t Vector2::length() const
{
	return sqrt(this->dot(*this));
}


inline real_t Vector2::squared_length() const
{
	return this->dot(*this);
}


inline Vector2 &Vector2::normalize()
{
	*this /= length();
	return *this;
}


inline bool Vector2::is_normalized() const
{
return false;
}


inline Vector2 &Vector2::scale(real_t a)
{
	*this *= a;
	return *this;
}


inline std::istream &operator>>(std::istream &s, Vector2 &v)
{
        return s >> v[0] >> v[1];
}


inline std::ostream &operator<<(std::ostream &s, const Vector2 &v)
{
	return s << v[0] << ' ' << v[1];
}


END_GTBMOUSENS
